ROOT_DIR := /home/prog/ADA/ARM/setup/rvs-sources
OUTPUT_DIR := $(ROOT_DIR)/output
TOOLCHAIN_DIR := $(OUTPUT_DIR)/toolchain
TOOLCHAIN_SRC_DIR := $(ROOT_DIR)/toolchain
DL_DIR = $(TOOLCHAIN_SRC_DIR)/dl


GNAT_BIN := $(DL_DIR)/gnat-gpl-2015-arm-elf-linux-bin.tar.gz
GNAT_SRC := $(DL_DIR)/gnat-gpl-2015-src.tar.gz
ZFP_SRC := $(DL_DIR)/bb-runtimes-gpl-2015-src.tar.gz
GCC_SRC := $(DL_DIR)/gcc-4.9-gpl-2015-src.tar.gz

GNAT_BIN_DIR = /usr/gnat

BUILD_RUNTIME_OPT := -v --no-link


all: $(TOOLCHAIN_DIR)/.stamp_built_sfp $(TOOLCHAIN_DIR)/.stamp_built_full

$(TOOLCHAIN_DIR)/.stamp_extracted:
	mkdir -p $(TOOLCHAIN_DIR)/src/gcc
	tar -C $(TOOLCHAIN_DIR)/src -xzf $(GNAT_SRC)
	tar --strip-components=1 -C $(TOOLCHAIN_DIR)/src/gcc -xzf $(GCC_SRC)
	tar -C $(TOOLCHAIN_DIR)/src -xzf $(ZFP_SRC)
	cd $(TOOLCHAIN_DIR)/src && ln -s gnat-gpl-2015-src/src/ada gnat
	@touch $@

$(TOOLCHAIN_DIR)/.stamp_patched: $(TOOLCHAIN_DIR)/.stamp_extracted
	cd $(TOOLCHAIN_DIR)/src/bb-runtimes-gpl-2015-src && \
            patch -p1 < $(TOOLCHAIN_SRC_DIR)/bb-runtimes-gpl-2015.patch
	cd $(TOOLCHAIN_DIR)/src/gnat-gpl-2015-src && \
            patch -p1 < $(TOOLCHAIN_SRC_DIR)/gnat-gpl-2015-src.patch
	@touch $@

$(TOOLCHAIN_DIR)/.stamp_built_full: $(TOOLCHAIN_DIR)/.stamp_patched
	cd $(TOOLCHAIN_DIR)/src/bb-runtimes-gpl-2015-src && \
           PATH=$(GNAT_BIN_DIR)/gnat/bin:$(PATH) \
	   ./build-all.sh  $(BUILD_RUNTIME_OPT) --target=sam4s full
	mkdir -p $(OUTPUT_DIR)/arm-eabi/lib/gnat/ravenscar-full-sam4s
	cd $(OUTPUT_DIR)/arm-eabi/lib/gnat/ravenscar-full-sam4s && \
           rsync -aPv $(TOOLCHAIN_DIR)/src/bb-runtimes-gpl-2015-src/install/ .
	@touch $@

$(TOOLCHAIN_DIR)/.stamp_built_sfp: $(TOOLCHAIN_DIR)/.stamp_patched
	cd $(TOOLCHAIN_DIR)/src/bb-runtimes-gpl-2015-src && \
           PATH=$(GNAT_BIN_DIR)/gnat/bin:$(PATH) \
	   ./build-all.sh $(BUILD_RUNTIME_OPT) --target=sam4s sfp
	mkdir -p $(OUTPUT_DIR)/arm-eabi/lib/gnat/ravenscar-sfp-sam4s
	cd $(OUTPUT_DIR)/arm-eabi/lib/gnat/ravenscar-sfp-sam4s && \
           rsync -aPv $(TOOLCHAIN_DIR)/src/bb-runtimes-gpl-2015-src/install/ .
	@touch $@

