----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with Interfaces; use Interfaces;

package Bitmaps is
   pragma Pure;

   type Bitmap is array (Unsigned_8 range <>, Unsigned_8 range <>)
       of Unsigned_8;
   --  Bitmap is output buffer type, first index - oled pages, second - oled columns.
   --  Element of bitmap is oled column value.

   --  bimap width and height in pixeles
   function Bitmap_Width (Bmp : Bitmap) return Unsigned_8;
   function Bitmap_Height (Bmp : Bitmap) return Unsigned_8;
   pragma Inline (Bitmap_Width, Bitmap_Height);

end Bitmaps;
