----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

package body Font is

   type Font_Type is array (Natural range <>) of Glyph_Type;

   Unknown_Char  : constant Glyph_Type :=
     (others => (2#01001001#,
                 2#01100011#,
                 2#00111110#,
                 2#01011101#,
                 2#00111110#,
                 2#01100011#,
                 2#01001001#,
                 2#00000000#));

   Digit_Font : constant Font_Type :=
     (
      --  '0' 16#30# ASCII
        (others => (2#00111110#,
                    2#01111111#,
                    2#01110001#,
                    2#01011001#,
                    2#01001101#,
                    2#01111111#,
                    2#00111110#,
                    2#00000000#)),
      --  '1'
      (others => (2#01000000#,
                  2#01000010#,
                  2#01111111#,
                  2#01111111#,
                  2#01000000#,
                  2#01000000#,
                  2#00000000#,
                  2#00000000#)),
      --  '2'
      (others => (2#01100010#,
                  2#01110011#,
                  2#01011001#,
                  2#01001001#,
                  2#01101111#,
                  2#01100110#,
                  2#00000000#,
                  2#00000000#)),

      --  '3'
      (others => (2#00100010#,
                  2#01100011#,
                  2#01001001#,
                  2#01001001#,
                  2#01111111#,
                  2#00110110#,
                  2#00000000#,
                  2#00000000#)),
      --  '4'
      (others => (2#00011000#,
                  2#00011100#,
                  2#00010110#,
                  2#01010011#,
                  2#01111111#,
                  2#01111111#,
                  2#01010000#,
                  2#00000000#)),
      --  '5'
      (others => (2#00100111#,
                  2#01100111#,
                  2#01000101#,
                  2#01000101#,
                  2#01111101#,
                  2#00111001#,
                  2#00000000#,
                  2#00000000#)),
      --  '6'
      (others => (2#00111100#,
                  2#01111110#,
                  2#01001011#,
                  2#01001001#,
                  2#01111001#,
                  2#00110000#,
                  2#00000000#,
                  2#00000000#)),
      --  '7'
      (others => (2#00000011#,
                  2#00000011#,
                  2#01110001#,
                  2#01111001#,
                  2#00001111#,
                  2#00000111#,
                  2#00000000#,
                  2#00000000#)),
      --  '8'
      (others => (2#00110110#,
                  2#01111111#,
                  2#01001001#,
                  2#01001001#,
                  2#01111111#,
                  2#00110110#,
                  2#00000000#,
                  2#00000000#)),
      --  '9'
      (others => (2#00000110#,
                  2#01001111#,
                  2#01001001#,
                  2#01101001#,
                  2#00111111#,
                  2#00011110#,
                  2#00000000#,
                  2#00000000#))
     );


   Alpha_Font : constant Font_Type :=
     (
      -- 'A' 16#41# ASCII
        (others => (2#01100000#,
                    2#01111000#,
                    2#00010110#,
                    2#00010011#,
                    2#00010110#,
                    2#01111000#,
                    2#01100000#,
                    2#00000000#)),
      -- 'B'
      (others => (2#01111111#,
                  2#01111111#,
                  2#01001001#,
                  2#01001001#,
                  2#01001001#,
                  2#01111111#,
                  2#00110110#,
                  2#00000000#)),
      -- 'C'
      (others => (2#00111110#,
                  2#01111111#,
                  2#01000001#,
                  2#01000001#,
                  2#01000001#,
                  2#01100011#,
                  2#00100010#,
                  2#00000000#)),
      -- 'D'
      (others => (2#01111111#,
                  2#01111111#,
                  2#01000001#,
                  2#01000001#,
                  2#01000001#,
                  2#01111111#,
                  2#00111110#,
                  2#00000000#)),
      -- 'E'
      (others => (2#01111111#,
                  2#01111111#,
                  2#01001001#,
                  2#01001001#,
                  2#01001001#,
                  2#01001001#,
                  2#01001001#,
                  2#00000000#)),
      -- 'F'
      (others => (2#01111111#,
                  2#01111111#,
                  2#00001001#,
                  2#00001001#,
                  2#00001001#,
                  2#00001001#,
                  2#00000001#,
                  2#00000000#)),
      -- 'G'
      (others => (2#00111110#,
                  2#01111111#,
                  2#01000001#,
                  2#01000001#,
                  2#01010001#,
                  2#01110011#,
                  2#00110010#,
                  2#00000000#)),
      -- 'H'
      (others => (2#01111111#,
                  2#01111111#,
                  2#00001000#,
                  2#00001000#,
                  2#00001000#,
                  2#01111111#,
                  2#01111111#,
                  2#00000000#)),
      -- 'I'
      (others => (2#01000001#,
                  2#01000001#,
                  2#01111111#,
                  2#01111111#,
                  2#01000001#,
                  2#01000001#,
                  2#00000000#,
                  2#00000000#)),
      -- 'J'
      (others => (2#00100000#,
                  2#01100000#,
                  2#01000001#,
                  2#01000001#,
                  2#01000001#,
                  2#01111111#,
                  2#00111111#,
                  2#00000000#)),
      -- 'K'
      (others => (2#01111111#,
                  2#01111111#,
                  2#00011000#,
                  2#00011100#,
                  2#00110110#,
                  2#01100011#,
                  2#01000001#,
                  2#00000000#)),
      -- 'L'
      (others => (2#01111111#,
                  2#01111111#,
                  2#01000000#,
                  2#01000000#,
                  2#01000000#,
                  2#01000000#,
                  2#01000000#,
                  2#00000000#)),
      -- 'M'
      (others => (2#01111111#,
                  2#01111111#,
                  2#00001100#,
                  2#00111000#,
                  2#00001100#,
                  2#01111111#,
                  2#01111111#,
                  2#00000000#)),
      -- 'N'
      (others => (2#01111111#,
                  2#01111111#,
                  2#00001100#,
                  2#00011000#,
                  2#00110000#,
                  2#01111111#,
                  2#01111111#,
                  2#00000000#)),
      -- 'O'
      (others => (2#00111110#,
                  2#01111111#,
                  2#01000001#,
                  2#01000001#,
                  2#01000001#,
                  2#01111111#,
                  2#00111110#,
                  2#00000000#)),
      -- 'P'
      (others => (2#01111111#,
                  2#01111111#,
                  2#00001001#,
                  2#00001001#,
                  2#00001001#,
                  2#00001111#,
                  2#00000110#,
                  2#00000000#)),
      -- 'Q'
      (others => (2#00011110#,
                  2#00111111#,
                  2#00100001#,
                  2#01111001#,
                  2#01100001#,
                  2#01111111#,
                  2#00011110#,
                  2#0000000#)),
      -- 'R'
      (others => (2#01111111#,
                  2#01111111#,
                  2#00001001#,
                  2#00001001#,
                  2#00001001#,
                  2#01111111#,
                  2#01110110#,
                  2#00000000#)),
      -- 'S'
      (others => (2#01000110#,
                  2#01001111#,
                  2#01001001#,
                  2#01001001#,
                  2#01001001#,
                  2#01111001#,
                  2#01110001#,
                  2#00000000#)),
      -- 'T'
      (others => (2#00000001#,
                  2#00000001#,
                  2#01111111#,
                  2#01111111#,
                  2#00000001#,
                  2#00000001#,
                  2#00000000#,
                  2#00000000#)),
      -- 'U'
      (others => (2#00111111#,
                  2#01111111#,
                  2#01000000#,
                  2#01000000#,
                  2#01000000#,
                  2#01111111#,
                  2#00111111#,
                  2#00000000#)),
      -- 'V'
      (others => (2#00000011#,
                  2#00001111#,
                  2#00111100#,
                  2#01110000#,
                  2#00111100#,
                  2#00001111#,
                  2#00000011#,
                  2#00000000#)),
      -- 'W'
      (others => (2#00001111#,
                  2#01111111#,
                  2#00110000#,
                  2#00011100#,
                  2#00110000#,
                  2#01111111#,
                  2#00001111#,
                  2#00000000#)),
      -- 'X'
      (others => (2#01100011#,
                  2#01110111#,
                  2#00010100#,
                  2#00001000#,
                  2#00010100#,
                  2#01110111#,
                  2#01100011#,
                  2#00000000#)),
      -- 'Y'
      (others => (2#00000011#,
                  2#00000111#,
                  2#01111100#,
                  2#01110000#,
                  2#01111100#,
                  2#00000111#,
                  2#00000011#,
                  2#00000000#)),
      -- 'Z'
      (others => (2#01100001#,
                  2#01110001#,
                  2#01010001#,
                  2#01001001#,
                  2#01001101#,
                  2#01000111#,
                  2#01000011#,
                  2#00000000#))
     );


   Punct_Font_1 : constant Font_Type :=
     (
      --  space - 16#20# ASCII
        (others => (2#00000000#,
                    2#00000000#,
                    2#00000000#,
                    2#00000000#,
                    2#00000000#,
                    2#00000000#,
                    2#00000000#,
                    2#00000000#)),
      --  !
      (others => (2#00000000#,
                  2#00000000#,
                  2#00000000#,
                  2#01101111#,
                  2#01101111#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#)),
      --
      (others => (2#00000000#,
                  2#00000011#,
                  2#00000011#,
                  2#00000000#,
                  2#00000011#,
                  2#00000011#,
                  2#00000000#,
                  2#00000000#)),
      -- #
      (others => (2#00100010#,
                  2#01111111#,
                  2#01111111#,
                  2#00100010#,
                  2#01111111#,
                  2#01111111#,
                  2#00100010#,
                  2#00000000#)),
      -- $
      (others => (2#01000110#,
                  2#01001111#,
                  2#01001001#,
                  2#01111111#,
                  2#01001001#,
                  2#01111001#,
                  2#00110001#,
                  2#00000000#)),

      -- %
      (others => (2#00000010#,
                  2#01100111#,
                  2#00110010#,
                  2#00011000#,
                  2#00101100#,
                  2#01110110#,
                  2#00100000#,
                  2#00000000#)),

      -- &
      (others => (2#00110000#,
                  2#01111010#,
                  2#01001111#,
                  2#01011101#,
                  2#00110010#,
                  2#01100000#,
                  2#01010000#,
                  2#00000000#)),
      -- '
      (others => (2#00000000#,
                  2#00000000#,
                  2#00000011#,
                  2#00000011#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#)),
      -- (
      (others => (2#00000000#,
                  2#00111110#,
                  2#01100011#,
                  2#01000001#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#)),
      -- )
      (others => (2#00000000#,
                  2#00000000#,
                  2#00000000#,
                  2#01000001#,
                  2#01100011#,
                  2#00111110#,
                  2#00000000#,
                  2#00000000#)),
      -- *
      (others => (2#00100010#,
                  2#00010100#,
                  2#00001000#,
                  2#01111111#,
                  2#00001000#,
                  2#00010100#,
                  2#00100010#,
                  2#00000000#)),
      -- +
      (others => (2#00000000#,
                  2#00001000#,
                  2#00001000#,
                  2#00111110#,
                  2#00001000#,
                  2#00001000#,
                  2#00000000#,
                  2#00000000#)),
      -- '
      (others => (2#00000000#,
                  2#00000000#,
                  2#00000011#,
                  2#00000011#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#)),
      -- -
      (others => (2#00000000#,
                  2#00001100#,
                  2#00001100#,
                  2#00001100#,
                  2#00001100#,
                  2#00001100#,
                  2#00000000#,
                  2#00000000#)),
      -- .
      (others => (2#00000000#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#,
                  2#01100000#,
                  2#01100000#,
                  2#00000000#)),
      -- /
      (others => (2#00100000#,
                  2#00110000#,
                  2#00011000#,
                  2#00001100#,
                  2#00000110#,
                  2#00000011#,
                  2#00000001#,
                  2#00000000#))
     );

   Punct_Font_2 : constant Font_Type :=
     (
      --  : - 16#3A# ASCII
        (others => (2#00000000#,
                    2#00000000#,
                    2#00000000#,
                    2#00110110#,
                    2#00110110#,
                    2#00000000#,
                    2#00000000#,
                    2#00000000#)),
      -- ;
      (others => (2#00000000#,
                  2#01000000#,
                  2#01100000#,
                  2#00110110#,
                  2#00010110#,
                  2#00000000#,
                  2#00000000#,
                  2#00000000#)),
      --  <
      (others => (2#00001000#,
                  2#00010100#,
                  2#00010100#,
                  2#00100010#,
                  2#00100010#,
                  2#01000001#,
                  2#01000001#,
                  2#00000000#)),
      --  =
      (others => (2#00000000#,
                  2#00110110#,
                  2#00110110#,
                  2#00110110#,
                  2#00110110#,
                  2#00110110#,
                  2#00110110#,
                  2#00000000#)),
      --  >
      (others => (2#01000001#,
                  2#01000001#,
                  2#00100010#,
                  2#00100010#,
                  2#00010100#,
                  2#00010100#,
                  2#00001000#,
                  2#00000000#)),
      --  ?
      (others => (2#00000010#,
                  2#00000011#,
                  2#01011001#,
                  2#01011001#,
                  2#01011111#,
                  2#00000110#,
                  2#00000000#,
                  2#00000000#))
     );

   function Get_Glyph (Char : Character) return Glyph_Type is
   begin
      if Char >= '0' and Char <= '9' then
         return Digit_Font (Character'Pos (Char) - 16#30#);
      elsif Char >= 'A' and Char <= 'Z' then
         return Alpha_Font (Character'Pos (Char) - 16#41#);
      elsif Char >= 'a' and Char <= 'z' then
         return Alpha_Font (Character'Pos (Char) - 16#61#);
      elsif Char >= ' ' and Char <= '0' then
         return Punct_Font_1 (Character'Pos (Char) - 16#20#);
      elsif Char >= ':' and Char <= '?' then
         return Punct_Font_2 (Character'Pos (Char) - 16#3A#);
      else
         return Unknown_Char;
      end if;
   exception when Constraint_Error =>
                return Unknown_Char;
   end Get_Glyph;

end Font;
