----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with Interfaces; use Interfaces;
with Oled.Draw;  use Oled.Draw;
with Bitmaps;    use Bitmaps;

package Oled.Buffered is
   type Bit_Oper is (Bit_Copy, Bit_Copy_Inverse, Bit_Xor,
                     Bit_Or, Bit_And);

   procedure Set_Pixel (Bmp   : in out Bitmap;
                        X, Y  : in     Unsigned_8;
                        Oper  : in     Bit_Oper := Bit_Copy);

   --  draw horizontal or vertical line in buffer Bmp
   procedure Draw_Horiz_Line (Bmp        : in out Bitmap;
                              Y, X1, X2  : in     Unsigned_8;
                              Oper       : in     Bit_Oper := Bit_Copy);

   procedure Draw_Vertic_Line (Bmp       : in out Bitmap;
                               X, Y1, Y2 : in     Unsigned_8;
                               Oper      : in     Bit_Oper := Bit_Copy);

   procedure Draw_Rect (Bmp             : in out Bitmap;
                        X1, Y1, X2, Y2  : in     Unsigned_8;
                        Oper  : in     Bit_Oper := Bit_Copy);

   procedure Bitmap_Copy (Dst_Bmp : in out Bitmap;
                          Src_Bmp : in     Bitmap;
                          Dst_X   : in     Unsigned_8;
                          Dst_Y   : in     Unsigned_8;
                          Oper    : in     Bit_Oper := Bit_Copy);

   procedure Bitmap_Copy (Dst_Bmp                        : in out Bitmap;
                          Src_Bmp                        : in     Bitmap;
                          Dst_X, Dst_Y                   : in Unsigned_8;
                          Src_X1, Src_Y1, Src_X2, Src_Y2 : in Unsigned_8;
                          Oper : in Bit_Oper := Bit_Copy);

   procedure Clear_Bitmap (Bmp  : in out Bitmap;
                           Byte : in     Unsigned_8 := 0);
end Oled.Buffered;
