----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------


with Font;
with Bitmaps; use Bitmaps;

package Oled.Draw is
   --  draw string in any specified position
   procedure Draw_String (Str : String;
                          Row : Oled_Page_Num;
                          X   : Oled_Col_Num);

   --  draw string in current position and increment current column
   procedure Draw_String (Str : String) with Inline;

   -- draw column pattern in any specified position
   -- Data bit 0 - upmost pixel in column
   -- Data bit 7 - lowermost pixel in column

   procedure Set_Column_Data (Row  : Oled_Page_Num;
                              X    : Oled_Col_Num;
                              Data : Unsigned_8) with Inline;

   -- Draw bitmap or bitmap part in specified Oled-position
   procedure Draw_Bitmap (Bmp            : Bitmap;
                          Bmp_Start_Row  : Unsigned_8;
                          Bmp_End_Row    : Unsigned_8;
                          Bmp_Start_Col  : Unsigned_8;
                          Bmp_End_Col    : Unsigned_8;
                          Oled_Start_Row : Oled_Page_Num;
                          Oled_Start_Col : Oled_Col_Num);

   --  draw only one bitmap-row in current position and increment current column
   procedure Draw_Bitmap_One_Row (Bmp : Bitmap;
                                  Bmp_Row  : Unsigned_8;
                                  Bmp_Start_Col  : Unsigned_8;
                                  Bmp_End_Col    : Unsigned_8) with Inline;

   procedure Set_Cursor (Row : Oled_Page_Num;
                         X   : Oled_Col_Num) with Inline;

   --  draw font glyph in current position and increment current column
   procedure Draw_Glyph (Glyph : Font.Glyph_Type) with Inline;
end Oled.Draw;
