----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with SAM4S; use SAM4S;
with Timer;

package body Oled_Drv is

   -----------------
   -- Reset_Delay --
   -----------------

   procedure Reset_Delay
   is
   begin
      Timer.Wait (1);
   end Reset_Delay;

   -----------
   -- Write --
   -----------

   procedure Write (Byte : Unsigned_8) is
   begin
      --  Set PCS #2
      SPI.SPI_MR := (SPI.SPI_MR and not SPI_MR.PCS_Mask)
        or (SPI_MR.PCS_Mask and not ((2 ** 2) * SPI_MR.PCS));

      --  Write
      SPI.SPI_TDR := Word (Byte);

      Wait_Ready;

      --  Deselect device
      SPI.SPI_MR := SPI.SPI_MR or SPI_MR.PCS_Mask;
       --  Last transfer
      SPI.SPI_CR := SPI_CR.LASTXFER;
   end Write;

   ----------------
   -- Wait_Ready --
   ----------------

   procedure Wait_Ready is
   begin
      while (SPI.SPI_SR and SPI_SR.TXEMPTY) = 0 loop
         null;
      end loop;
   end Wait_Ready;
end Oled_Drv;
