----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with Ada.Real_Time; use Ada.Real_Time;
with Interfaces; use Interfaces;
with Oled; use Oled;
with Demo_Proc;
with XSTK_Board;
with XSTK_Oled1_Board;

procedure Main
is
   -- main led control
   Ld : Boolean := False;
   -- first line viewed on the screen
   Start_Line : Integer := 0;
   --  control of inversion
   Norm_Disp : Boolean := True;

   -- index the demo-procedure
   Demo_Index : Integer := 0;
   -- step in the demo-procedure

   Cur_Time :Time := Clock;
   Last_Butt_Click_Tm  : Time := Cur_Time;
begin
   XSTK_Board.Init;
   XSTK_Oled1_Board.Init;

   XSTK_Board.LED0_Off;

   Oled.Init;

   loop
      XSTK_Board.LED0_Toggle;

      Ld := not Ld;

      if XSTK_Oled1_Board.Button (1) or else Demo_Index = 0 then
         Cur_Time := Clock;

         if Cur_Time > Last_Butt_Click_Tm +  Milliseconds (1000)

         then
            if Demo_Index < Demo_Proc.Demo_List'Last then
               Demo_Index := Demo_Index + 1;
            else
               Demo_Index := Demo_Proc.Demo_List'First;
            end if;

            Demo_Proc.Demo_List (Demo_Index)(Start => True);

            Last_Butt_Click_Tm  := Cur_Time;
         end if;
      else
         Demo_Proc.Demo_List (Demo_Index)(Start => False);
      end if;

      if XSTK_Oled1_Board.Button (2) then
         Demo_Proc.Pause_Toggle;
      end if;

      if XSTK_Oled1_Board.Button (3) then
         Norm_Disp := not Norm_Disp;
         Oled.Invert (Norm_Disp);
      end if;

      delay until Clock +  Milliseconds (100);
   end loop;
end Main;
