/* This start module is intended for compile executable into RAM SAM4.
author Turishev E.V. */

        .syntax unified
        .cpu cortex-m4
        .thumb

        /* This is the initial vector table. Ravenscar runtimes install its own table (using
           VTOR register) defined in handler.S.*/
        .section .vectors,"a"
__vectors0:
        b.w     _my_start_ram   /* stack top address */
        .word   _my_start_ram   /* 1 Reset */
        .word   hang            /* 2 NMI */
        .word   hang            /* 3 HardFault */
        .word   hang            /* 4 MemManage */
        .word   hang            /* 5 BusFault  */
        .word   hang            /* 6 UsageFault */
        .word   0, 0, 0, 0      /* 7, 8, 9, 10 : Reserved */
        .word   hang            /* 11 SVC_Handler  */
        .word   hang            /* 12 DebugMon */
        .word   0               /* 13 Reserved  */
        .word   hang            /* 14 PendSV */

        .text

        .thumb_func
        .globl _my_start_ram
_my_start_ram:
        cpsid i
        movw    r0,#:lower16:__stack_end
        movt    r0,#:upper16:__stack_end
        mov     sp,r0

1:
        /* Clear .bss */
        movw    r0,#:lower16:__bss_start
        movt    r0,#:upper16:__bss_start
        movw    r1,#:lower16:__bss_words
        mov     r2,#0
        cbz     r1,1f
0:      str     r2,[r0],#4
        subs    r1,r1,#1
        bne     0b

1:
        bl      _ada_setup_pll
        bl      main
        bl      exit

        .global __aeabi_unwind_cpp_pr0
        .global __aeabi_unwind_cpp_pr1
        .global __aeabi_unwind_cpp_pr2
        .thumb_func
__aeabi_unwind_cpp_pr0:
        .thumb_func
__aeabi_unwind_cpp_pr1:
        .thumb_func
__aeabi_unwind_cpp_pr2:
        .thumb_func
hang:
        b .
