----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with Interfaces; use Interfaces;

package SAM4S_Init is


   Number_Of_IRQ : constant := 35;

   subtype IRQ_Id is Natural range 0 .. Number_Of_IRQ - 1;

   SUPC_IRQ_Id     : constant IRQ_Id := 0;
   RSTC_IRQ_Id     : constant IRQ_Id := 1;
   RTC_IRQ_Id      : constant IRQ_Id := 2;
   RTT_IRQ_Id      : constant IRQ_Id := 3;
   WDT_IRQ_Id      : constant IRQ_Id := 4;
   PMC_IRQ_Id      : constant IRQ_Id := 5;
   EEFC0_IRQ_Id    : constant IRQ_Id := 6;
   EEFC1_IRQ_Id    : constant IRQ_Id := 7;
   UART0_IRQ_Id    : constant IRQ_Id := 8;
   UART1_IRQ_Id    : constant IRQ_Id := 9;
   SMC_IRQ_Id      : constant IRQ_Id := 10;
   PIOA_IRQ_Id     : constant IRQ_Id := 11;
   PIOB_IRQ_Id     : constant IRQ_Id := 12;
   PIOC_IRQ_Id     : constant IRQ_Id := 13;
   USART0_IRQ_Id   : constant IRQ_Id := 14;
   USART1_IRQ_Id   : constant IRQ_Id := 15;
   -- 16, 17 - reserved
   GSMCI_IRQ_Id    : constant IRQ_Id := 18;
   TWI0_IRQ_Id     : constant IRQ_Id := 19;
   TWO1_IRQ_Id     : constant IRQ_Id := 20;
   SPI_IRQ_Id      : constant IRQ_Id := 21;
   SSC_IRQ_Id      : constant IRQ_Id := 22;
   TC0_IRQ_Id      : constant IRQ_Id := 23;
   TC1_IRQ_Id      : constant IRQ_Id := 24;
   TC2_IRQ_Id      : constant IRQ_Id := 25;
   TC3_IRQ_Id      : constant IRQ_Id := 26;
   TC4_IRQ_Id      : constant IRQ_Id := 27;
   TC5_IRQ_Id      : constant IRQ_Id := 28;
   ADC_IRQ_Id      : constant IRQ_Id := 29;
   DACC_IRQ_Id     : constant IRQ_Id := 30;
   PWM_IRQ_Id      : constant IRQ_Id := 31;
   CRCCU_IRQ_Id    : constant IRQ_Id := 32;
   ACC_IRQ_Id      : constant IRQ_Id := 33;
   UDP_IRQ_Id      : constant IRQ_Id := 34;

   type IRQ_Handler is access procedure (Id : IRQ_Id);

   subtype Priority is Natural range  0 .. 15;

   procedure Init (Main_Priority : Priority := 1);


   procedure Set_IRQ_Handler (Id      : IRQ_Id;
                              Handler : IRQ_Handler;
                              Prior   : Priority := 8);

   procedure Disable_Interrupts;
   procedure Enable_Interrupts;
   procedure Set_Current_Priority (Prior : Priority);
end SAM4S_Init;
