/* This start module is intended for compile executable into RAM SAM4.
author Turishev E.V. */


        .syntax unified
        .cpu cortex-m4
        .thumb

        .section .vectors,"a"
        .globl  __vectors
__vectors:
        .word   __stack_end /* stack top address */
        .word   _start_rom  /* 1 Reset */
        .word   Fault_Handler      /* 2 NMI.  */
        .word   Fault_Handler      /* 3 Hard fault. */
        .word   Fault_Handler      /* 4 Mem manage.  */
        .word   Fault_Handler      /* 5 Bus fault.  */
        .word   Fault_Handler      /* 6 Usage fault.  */
        .word   Fault_Handler      /* 7 reserved.  */
        .word   Fault_Handler      /* 8 reserved.  */
        .word   Fault_Handler      /* 9 reserved.  */
        .word   Fault_Handler      /* 10 reserved.  */
        .word   Fault_Handler      /* 11 SVCall.  */
        .word   Fault_Handler      /* 12 Reserved for Debug.  */
        .word   Fault_Handler      /* 13 Reserved.  */
        .word   Fault_Handler      /* 14 PendSV.  */
        .word   SysTick_Handler    /* 15 Systick.*/
        .word   IRQ_Handler        /* 16 IRQ0.  */
        .word   IRQ_Handler        /* 17 IRQ1.  */
        .word   IRQ_Handler        /* 18 IRQ2.  */
        .word   IRQ_Handler        /* 19 IRQ3.  */
        .word   IRQ_Handler        /* 20 IRQ4.  */
        .word   IRQ_Handler        /* 21 IRQ5.  */
        .word   IRQ_Handler        /* 22 IRQ6.  */
        .word   IRQ_Handler        /* 23 IRQ7.  */
        .word   IRQ_Handler        /* 24 IRQ8.  */
        .word   IRQ_Handler        /* 25 IRQ9.  */
        .word   IRQ_Handler        /* 26 IRQ10.  */
        .word   IRQ_Handler        /* 27 IRQ11.  */
        .word   IRQ_Handler        /* 28 IRQ12.  */
        .word   IRQ_Handler        /* 29 IRQ13.  */
        .word   IRQ_Handler        /* 30 IRQ14.  */
        .word   IRQ_Handler        /* 31 IRQ15.  */
        .word   IRQ_Handler        /* 32 IRQ16.  */
        .word   IRQ_Handler        /* 33 IRQ17.  */
        .word   IRQ_Handler        /* 34 IRQ18.  */
        .word   IRQ_Handler        /* 35 IRQ19.  */
        .word   IRQ_Handler        /* 36 IRQ20.  */
        .word   IRQ_Handler        /* 37 IRQ21.  */
        .word   IRQ_Handler        /* 38 IRQ22.  */
        .word   IRQ_Handler        /* 39 IRQ23.  */
        .word   IRQ_Handler        /* 40 IRQ24.  */
        .word   IRQ_Handler        /* 41 IRQ25.  */
        .word   IRQ_Handler        /* 42 IRQ26.  */
        .word   IRQ_Handler        /* 43 IRQ27.  */
        .word   IRQ_Handler        /* 44 IRQ28.  */
        .word   IRQ_Handler        /* 45 IRQ29.  */
        .word   IRQ_Handler        /* 46 IRQ30.  */
        .word   IRQ_Handler        /* 47 IRQ31.  */
        .word   IRQ_Handler        /* 48 IRQ32.  */
        .word   IRQ_Handler        /* 49 IRQ33.  */
        .word   IRQ_Handler        /* 50 IRQ34.  */
        .word   IRQ_Handler        /* 51 IRQ35.  */
        .word   IRQ_Handler        /* 52 IRQ36.  */

        .text

        .thumb_func
        .globl _start_rom
_start_rom:
        /* disable fault and interrupts */
        cpsid   i
        cpsid   f

        /* set VTOR register to start of interrupt vectors table */
        movw    r0,#:lower16:__vectors
        movt    r0,#:upper16:__vectors
        /* VTOR register address */
        movw    r1,#60680       /*ED08*/
        movt    r1,#57344       /*E000*/
        str     r0,[r1]

        /* Copy .data */
        movw    r0,#:lower16:__data_start
        movt    r0,#:upper16:__data_start
        movw    r1,#:lower16:__data_words
        movw    r2,#:lower16:__data_load
        movt    r2,#:upper16:__data_load
        cbz     r1,1f
0:      ldr     r4,[r2],#4
        str     r4,[r0],#4
        subs    r1,r1,#1
        bne     0b

1:
        /* Clear .bss */
        movw    r0,#:lower16:__bss_start
        movt    r0,#:upper16:__bss_start
        movw    r1,#:lower16:__bss_words
        mov     r2,#0
        cbz     r1,1f
0:      str     r2,[r0],#4
        subs    r1,r1,#1
        bne     0b

1:
        bl      _ada_setup_pll
        bl      main
        bl      exit

        .global __aeabi_unwind_cpp_pr0
        .global __aeabi_unwind_cpp_pr1
        .global __aeabi_unwind_cpp_pr2
        .thumb_func
__aeabi_unwind_cpp_pr0:
        .thumb_func
__aeabi_unwind_cpp_pr1:
        .thumb_func
__aeabi_unwind_cpp_pr2:
        .thumb_func
hang:
        b .
