----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

pragma Restrictions (No_Elaboration_Code);

with Interfaces; use Interfaces;

package Timer is
   subtype Tick_Count is Unsigned_32;

   procedure Init;

   function Ticks return Tick_Count;
   procedure Wait (Cnt : Tick_Count);

   type Timer_Callback is access procedure (Ticks : Tick_Count);

   procedure Set_Callback (Cb : Timer_Callback);
end Timer;
