----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

package body Adc is
   Main_Clock : constant := 12_000_000; -- 12 MHz Oscillator

   procedure Config_Trigger (Trig : ADC_Trigger_Type; Free_Run : Boolean)
   is
      FR : Word := 0;
   begin
      if Free_Run then
         FR := 1;
      end if;

      ADC.MR := ADC.MR or FR * 2 ** 7 or (Word (Trig) and 255);
   end Config_Trigger;

   procedure Enable_Channel (Channel : ADC_Channel_Type) is
   begin
      ADC.CHER := 1 * 2 ** Channel;
   end Enable_Channel;

   procedure Init (Clock_HZ : Natural; Startup_Time : ADC_Startup_Time_Type)
   is
      Prescal : constant Natural  := Main_Clock / (2 * Clock_HZ) - 1;
   begin
      ADC.CR := ADC_CR.SWRST;
      ADC.MR := (Word (Prescal) and 16#FFFF#) * 2 ** 8
        or Word (Startup_Time) * 2 ** 16;
   end Init;

   function Get_Value (Channel : ADC_Channel_Type) return Word is
   begin
      return ADC.CDR (Channel);
   end Get_Value;

   procedure Start is
   begin
      ADC.CR := ADC_CR.START;
   end Start;
end Adc;
