----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with SAM4S; use SAM4S;

package IO_Ports is
   pragma Preelaborate;

   subtype Device_Id is Natural range 0 .. 31;
   type Port_Id is (Port_A, Port_B, Port_C);

   subtype Port_Pin is Natural range 0 .. 31;

   type Port_Mode is (Port_Mode_Off, Port_Mode_In, Port_Mode_Out);

   procedure Port_Config (Port : Port_Id;
                          Pin  : Port_Pin;
                          Mode : Port_Mode);

   procedure Port_Config (Port : Port_Id;
                          Mask : Word;
                          Mode : Port_Mode);

   procedure Enable_Clock (Dev_Id : Device_Id);

   function Check (Port : Port_Id; Pin : Port_Pin) return Boolean;
   procedure Set (Port : Port_Id; Pin : Port_Pin);
   procedure Clear (Port : Port_Id; Pin : Port_Pin);
   procedure Toogle (Port : Port_Id; Pin : Port_Pin);

   procedure Enable_Interrupt (Port : Port_Id; Pin : Port_Pin);
   procedure Disable_Interrupt (Port : Port_Id; Pin : Port_Pin);
   function Check_Interrupt (Port : Port_Id; Pin : Port_Pin) return Boolean;

end IO_Ports;
