----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with SAM4S; use SAM4S;
with IO_Ports;

package body XSTK_Board is


   ----------------
   -- SW0_Button --
   ----------------

   function SW0_Button return Boolean is
   begin
      return IO_Ports.Check (SW0_Button_Port, SW0_Button_Pin);
   end SW0_Button;

   -------------
   -- LED0_On --
   -------------

   procedure LED0_Off is
   begin
      IO_Ports.Set (Led0_Port, Led0_Pin);
   end LED0_Off;

   -------------
   -- LED0_On --
   -------------

   procedure LED0_On is
   begin
      IO_Ports.Clear (Led0_Port, Led0_Pin);
   end LED0_On;

   procedure LED0_Toggle is
   begin
      IO_Ports.Toogle (Led0_Port, Led0_Pin);
   end LED0_Toggle;

   procedure Init is
   begin
      Port_Config (Port => Led0_Port,
                   Pin  => Led0_Pin,
                   Mode => Port_Mode_Out);

      Port_Config (Port => SW0_Button_Port,
                   Pin  => SW0_Button_Pin,
                   Mode => Port_Mode_In);
   end Init;
end XSTK_Board;
