----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with IO_Ports;

package XSTK_Oled1_Board is
   pragma Preelaborate;

   subtype Led_Num is Natural range 1 .. 3;
   subtype Button_Num is Natural range 1 .. 3;

   procedure Init;

   function Button (Num : Button_Num) return Boolean;

   procedure Led_On (Num : Led_Num);

   procedure Led_Off (Num : Led_Num);

   procedure Led_Toggle (Num : Led_Num);

   function Button_Port (Num : Button_Num) return IO_Ports.Port_Id
     with Inline;
   function Button_Pin (Num : Button_Num) return IO_Ports.Port_Pin
     with Inline;
end XSTK_Oled1_Board;
