----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with Interfaces; use Interfaces;
with SAM4S_Init;
with Ada.Text_IO; use Ada.Text_IO;
with XSTK_Board;
with XSTK_Oled1_Board;
with Butt_Intr;
with Timer;

procedure Main
is
   Next_Tick : Timer.Tick_Count := 0;
begin
   SAM4S_Init.Init;
   XSTK_Board.Init;
   XSTK_Oled1_Board.Init;

   Timer.Set_Callback (Butt_Intr.Timer_Cb'Access);

   Butt_Intr.Init;

   SAM4S_Init.Set_IRQ_Handler (SAM4S_Init.PIOC_IRQ_Id,
                               Butt_Intr.Button_Intr_Handler'Access,
                               Prior => 2);

   SAM4S_Init.Set_IRQ_Handler (SAM4S_Init.PIOA_IRQ_Id,
                               Butt_Intr.Button_Intr_Handler'Access,
                               Prior => 3);

   loop
      if Timer.Ticks > Next_Tick then
         XSTK_Board.LED0_Toggle;
         Next_Tick :=  Timer.Ticks + 200;
      end if;
   end loop;
end Main;
