#! /bin/sh
NAME=proj

INSTALL=/usr/gnat

ZFP_SUP_FILES=../sam4s-zfp-support
OBJ=obj

rm -f $OBJ/* lib/*

GENERAL_OPT="-v -Xmode=debug  -XLOADER=USER"

gprbuild  ${NAME}.gpr ${GENERAL_OPT} -XBUILD_VARIANT=RAM --create-map-file=${NAME}_ram.map \
            -largs -nostdinc -nodefaultlibs -nostartfiles -T ${ZFP_SUP_FILES}/proj-ram.ld

arm-eabi-objdump -h -S ${OBJ}/${NAME}_ram.elf > ${OBJ}/${NAME}_ram.lss

gprbuild  ${NAME}.gpr ${GENERAL_OPT} -XBUILD_VARIANT=ROM --create-map-file=${NAME}_rom.map \
            -largs -nostdinc -nodefaultlibs -nostartfiles -T ${ZFP_SUP_FILES}/proj-rom.ld

arm-eabi-objdump -h -S ${OBJ}/${NAME}_rom.elf > ${OBJ}/${NAME}_rom.lss
