----------------------------------------------------------------------------
-- Copyright (c) 2015 Turishev Evgeniy <ew_turi@mail.ru>                  --
-- This file is licensed under the GNU General Public License version 3   --
--  or any later version.                                                 --
----------------------------------------------------------------------------

with Interfaces; use Interfaces;
with SAM4S_Init;
with XSTK_Board;
with XSTK_Oled1_Board;
with Timer;
with Oled;
with Demo_Proc;


procedure Main
is
   -- first line viewed on the screen
   Start_Line : Integer := 0;
   --  control of inversion
   Norm_Disp : Boolean := True;

   -- index the demo-procedure
   Demo_Index : Integer := 0;
   -- step in the demo-procedure

   Cur_Time : Timer.Tick_Count := Timer.Ticks;
   Last_Butt_Click_Tm : Timer.Tick_Count := Cur_Time;
begin
   SAM4S_Init.Init;

   XSTK_Board.Init;
   XSTK_Oled1_Board.Init;

   XSTK_Board.LED0_Off;

   Oled.Init;

   loop
      XSTK_Board.LED0_Toggle;

      if XSTK_Oled1_Board.Button (1) or else Demo_Index = 0 then
         Cur_Time := Timer.Ticks;

         if Cur_Time > Last_Butt_Click_Tm +  1000

         then
            if Demo_Index < Demo_Proc.Demo_List'Last then
               Demo_Index := Demo_Index + 1;
            else
               Demo_Index := Demo_Proc.Demo_List'First;
            end if;

            Demo_Proc.Demo_List (Demo_Index)(Start => True);

            Last_Butt_Click_Tm  := Cur_Time;
         end if;
      else
         Demo_Proc.Demo_List (Demo_Index)(Start => False);
      end if;

      if XSTK_Oled1_Board.Button (2) then
         Demo_Proc.Pause_Toggle;
      end if;

      if XSTK_Oled1_Board.Button (3) then
         Norm_Disp := not Norm_Disp;
         Oled.Invert (Norm_Disp);
      end if;

      Timer.Wait (200);
   end loop;
end Main;
